#ifndef RAWRUNV0_H
#define RAWRUNV0_H
/*
#include "DAQDataFormats/RawRunHeader.h"
#include "DAQDataFormats/RawRunTail.h"
#include "DAQDataFormats/RawConfigurationBlock.h"
#include "DAQDataFormats/RawEvent.h"


namespace daqdataformats {
    
  class RawRunV0 : public RawDAQData {
    
        public:
            // Constructors
            RawRunV0 (); //! The default constructor
            ~RawRunV0();

            bool setConfigurationBlock (const RawConfigurationBlock&  copyin);
            bool setConfigurationBlock (void* configuration_block_pointer);

            bool close();
            
        /// boost::bind is behaving.
        /// For example,  SOMETIMES (not always) when I bind a boost::function to RawNanoSliceHeaderV0::init
        /// then when I'm calling it from derived class RawNanoSliceHeader, it executes
        /// RawNanoSliceHeader::init
        /// But if I bind to RawNanoSliceHeaderV0::init1, then it works fine
        /// So, I'll do that for now and declare all methods in each version class with "1" at the end of the name
        /// and make them protected, so that users can't use init1 directly.
        /// Denis Perevalov
        protected:
            bool setFloatingEventToBufferSource (void* internal_buffer_pointer) const;

            INIT_CUSTOM_FUNCTION_PROTECTED                    (setConfigurationBlock1, bool, const RawConfigurationBlock&)
            INIT_CUSTOM_FUNCTION_PROTECTED                    (setConfigurationBlock2, bool, void*)
            
            INIT_CUSTOM_FUNCTION                              (addEvent       , bool, void*)

            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT                (getHeader, RawRunHeader*)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT                (getTail, RawRunTail*)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT                (getConfigurationBlock, RawConfigurationBlock*)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT                (getFloatingEvent, RawEvent*)

            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST_PROTECTED(getHeaderConst            , RawRunHeader*)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST_PROTECTED(getTailConst              , RawRunTail*)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST_PROTECTED(getConfigurationBlockConst, RawConfigurationBlock*)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST_PROTECTED(getFloatingEventConst     , RawEvent*)

            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getVersion                , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getMarkerHi               , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getMarkerLo               , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunNumber              , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunType                , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getConfigIDX              , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getPartition              , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getSubrun                 , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getConfigurationBlockSet  , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunControlVersion      , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunControlID           , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getDataLoggerVersion      , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getDataLoggerID           , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunStartTime           , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getSubRunStartTime        , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getSubRunEndTime          , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunEndTime             , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getTotalEvents            , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getUniversalEventStartLo  , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getUniversalEventStartHi  , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getUniversalEventStart    , uint64_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getUniversalEventEndLo    , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getUniversalEventEndHi    , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getUniversalEventEnd      , uint64_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getRunSize                , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getTriggerVersion         , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getTriggerCtrlID          , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getTriggerMC              , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getVTMod                  , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getValidTriggerTypesLow   , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getValidTriggerTypesHigh  , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getValidTriggerTypesHigh2 , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getTriggerListIDX         , uint32_t)
            INIT_CUSTOM_FUNCTION_WITH_NO_INPUT_CONST          (getTriggerPrescaleListIDX , uint32_t)

            INIT_CUSTOM_FUNCTION_CONST                        (setFloatingEvent          , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setRunNumber              , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setRunType                , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setConfigIDX              , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setPartition              , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setSubrun                 , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setRunControlVersion      , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setRunControlID           , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setDataLoggerVersion      , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setDataLoggerID           , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setRunStartTime           , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setSubRunStartTime        , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setSubRunEndTime          , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setRunEndTime             , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setTriggerCtrlID          , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setTriggerListIDX         , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (setTriggerPrescaleListIDX , bool, uint32_t)
            INIT_CUSTOM_FUNCTION                              (close                     , bool, bool)

            INIT_CUSTOM_FUNCTION_PROTECTED (figureOutEventSize                           , uint32_t, void*)
            INIT_CUSTOM_FUNCTION_PROTECTED (figureOutEventSizeWithoutFiguringOutVersion  , uint32_t, void*)



            /// Standard methods that we put in the first version of the class (like RawNanoSliceV0, RawMilliSliceV0, or RawEventV0)
            /// Need to plug this in in the class definition
            /// Fully defines, but lacks of implementation the following methods:
            ///         init, print, readData, sizeofdata, setBufferSource, getMasksAndCalculateShifts and setFunctionPointers
            ///     setFunctionPointers is to define setting function pointers
            ///     This last function has to be defined for each DAQDataFormats class, including each version
            STANDARD_METHODS_IN_DEFINITION_OF_THE_FIRST_VERSION_CLASS;
            IMPLEMENT_BINDING_SIZEOFDATA(RawRunV0)

        protected:
    
            RawRunHeader*           _Header;              //<! Run Header
            mutable RawRunTail*     _Tail;                //<! Run Tail
            RawConfigurationBlock*  _ConfigurationBlock;  //<! Configuration block
            mutable RawEvent*       _FloatingEvent;       //<! Floating Event
            RawEventHeader*         _auxEventHeader;      //<! Auxillary Event Header

            mutable int32_t         _FloatingEventNumber; //<! Floating Event Number

            version_t               _eventVersion;
            version_t               _configurationBlockVersion;


  };
  
  
} // END NAMESPCE daqdataformats
 *
 */
#endif /* RAWRUNV0_H */
