#include "DAQDataFormats/RawRunTail.h"
#include "DAQDataFormats/DataFormatException.h"

using namespace daqdataformats;

//------------------------------------------------------------------------------
RawRunTail::RawRunTail(const version_t version):
    RawRunHeader(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    setTail();
}

//------------------------------------------------------------------------------
RawRunTail::RawRunTail(const RawRunTail& copy_in):
    RawRunHeader(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
}

//------------------------------------------------------------------------------
RawRunTail::RawRunTail(const void* buffer, const version_t version):
    RawRunHeader(buffer, version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
}

//------------------------------------------------------------------------------
// Destructor
RawRunTail::~RawRunTail() { }


//------------------------------------------------------------------------------
// Default initialization at wherever the pointer points
void RawRunTail::init(){
    RawRunHeader::init();
    setTail();
}
