#include "DAQDataFormats/RawTriggerMask.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerMask
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggermask
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats{

//------------------------Constructors------------------------------------------
/// After this constructor the buffer pointer is set to the internal source
RawTriggerMask::RawTriggerMask(const version_t version):
     PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    /// Apply the default constructor
    defaultConstructorFixedSize();
}

//------------------------------------------------------------------------------
RawTriggerMask::RawTriggerMask(const RawTriggerMask& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    lastOperationsInDeepCopy(copy_in);
}

//------------------------------------------------------------------------------
RawTriggerMask::RawTriggerMask(const void* buffer, const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    /// Use default Shallow copy constructor
    copy(buffer);
}
 
RawTriggerMask::~RawTriggerMask(){ }

//------------------------------------------------------------------------------
/// All binding routines
#define STANDARD_ROUTINES                                       \
            BIND_GET_AND_SET(Version       , version0, uint32_t)\
            BIND_GET_AND_SET(MonteCarloFlag, version0, uint32_t)\
            BIND_GET_AND_SET(TrigMod       , version0, uint32_t)\
            BIND_GET_AND_SET(TrigMask_Low  , version0, uint32_t)\
            BIND_GET_AND_SET(TrigMask_High , version0, uint32_t)\
            BIND_GET_AND_SET(TrigMask_High2, version0, uint32_t)\
            BIND_GET_AND_SET(Prescale      , version0, uint32_t)\
            BIND_GET_AND_SET(TriggerMask   , version0, uint32_t)\
            BIND_STADARD_FUNCTION(sizeofdata); \
            BIND_STADARD_FUNCTION(readData);

#include "DAQDataFormats/setFunctionPointers_template.inc"



}// end of namespace