// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include <NovaDatabase/NovaDatabase.h>

namespace nova
{
  namespace database
  {
    template <class X>
    struct copyTraits
    {
      static void copyNeededFields(X const& source, X& target) {}
      template <class Y>
      static void copyNeededFields(X const& source, Y& target) {}
    };

    template <>
    struct copyTraits<Tolerance_t>
    {
      static void copyNeededFields(Tolerance_t const& source, Tolerance_t& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(Tolerance_t const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<dBCheck_t>
    {
      static void copyNeededFields(dBCheck_t const& source, dBCheck_t& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(dBCheck_t const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<dBColumn_t>
    {
      static void copyNeededFields(dBColumn_t const& source, dBColumn_t& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(dBColumn_t const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<dBRow_t>
    {
      static void copyNeededFields(dBRow_t const& source, dBRow_t& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(dBRow_t const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<dBTable>
    {
      static void copyNeededFields(dBTable const& source, dBTable& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(dBTable const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    // Tolerance_t
    // 

    const Tolerance_t::tolValue_type& Tolerance_t::
    tolValue () const
    {
      return this->tolValue_.get ();
    }

    Tolerance_t::tolValue_type& Tolerance_t::
    tolValue ()
    {
      return this->tolValue_.get ();
    }

    const Tolerance_t::tolValue_type& Tolerance_t::
    getTolValue () const
    {
      return this->tolValue_.get ();
    }

    bool Tolerance_t::
    hasTolValue () const
    {
      return this->tolValue_.present ();
    }

    void Tolerance_t::
    tolValue (const tolValue_type& x)
    {
      this->tolValue_.set (x);
    }

    void Tolerance_t::
    setTolValue (const tolValue_type& x)
    {
      this->tolValue_.set (x);
    }

    const Tolerance_t::tolType_type& Tolerance_t::
    tolType () const
    {
      return this->tolType_.get ();
    }

    Tolerance_t::tolType_type& Tolerance_t::
    tolType ()
    {
      return this->tolType_.get ();
    }

    const Tolerance_t::tolType_type& Tolerance_t::
    getTolType () const
    {
      return this->tolType_.get ();
    }

    bool Tolerance_t::
    hasTolType () const
    {
      return this->tolType_.present ();
    }

    void Tolerance_t::
    tolType (const tolType_type& x)
    {
      this->tolType_.set (x);
    }

    void Tolerance_t::
    setTolType (const tolType_type& x)
    {
      this->tolType_.set (x);
    }

    void Tolerance_t::
    tolType (::std::auto_ptr< tolType_type > x)
    {
      this->tolType_.set (x);
    }


    // dBColumn_t
    // 

    const dBColumn_t::tolerance_optional& dBColumn_t::
    tolerance () const
    {
      return this->tolerance_;
    }

    dBColumn_t::tolerance_optional& dBColumn_t::
    tolerance ()
    {
      return this->tolerance_;
    }

    const dBColumn_t::tolerance_type& dBColumn_t::
    getTolerance () const
    {
      return this->tolerance_.get ();
    }

    bool dBColumn_t::
    hasTolerance () const
    {
      return this->tolerance_.present ();
    }

    void dBColumn_t::
    tolerance (const tolerance_type& x)
    {
      this->tolerance_.set (x);
    }

    void dBColumn_t::
    setTolerance (const tolerance_type& x)
    {
      this->tolerance_.set (x);
    }

    void dBColumn_t::
    tolerance (const tolerance_optional& x)
    {
      this->tolerance_ = x;
    }

    void dBColumn_t::
    tolerance (::std::auto_ptr< tolerance_type > x)
    {
      this->tolerance_.set (x);
    }

    const dBColumn_t::name_type& dBColumn_t::
    name () const
    {
      return this->name_.get ();
    }

    dBColumn_t::name_type& dBColumn_t::
    name ()
    {
      return this->name_.get ();
    }

    const dBColumn_t::name_type& dBColumn_t::
    getName () const
    {
      return this->name_.get ();
    }

    bool dBColumn_t::
    hasName () const
    {
      return this->name_.present ();
    }

    void dBColumn_t::
    name (const name_type& x)
    {
      this->name_.set (x);
    }

    void dBColumn_t::
    setName (const name_type& x)
    {
      this->name_.set (x);
    }

    void dBColumn_t::
    name (::std::auto_ptr< name_type > x)
    {
      this->name_.set (x);
    }

    const dBColumn_t::colType_optional& dBColumn_t::
    colType () const
    {
      return this->colType_;
    }

    dBColumn_t::colType_optional& dBColumn_t::
    colType ()
    {
      return this->colType_;
    }

    const dBColumn_t::colType_type& dBColumn_t::
    getColType () const
    {
      return this->colType_.get ();
    }

    bool dBColumn_t::
    hasColType () const
    {
      return this->colType_.present ();
    }

    void dBColumn_t::
    colType (const colType_type& x)
    {
      this->colType_.set (x);
    }

    void dBColumn_t::
    setColType (const colType_type& x)
    {
      this->colType_.set (x);
    }

    void dBColumn_t::
    colType (const colType_optional& x)
    {
      this->colType_ = x;
    }

    void dBColumn_t::
    colType (::std::auto_ptr< colType_type > x)
    {
      this->colType_.set (x);
    }

    const dBColumn_t::value_optional& dBColumn_t::
    value () const
    {
      return this->value_;
    }

    dBColumn_t::value_optional& dBColumn_t::
    value ()
    {
      return this->value_;
    }

    const dBColumn_t::value_type& dBColumn_t::
    getValue () const
    {
      return this->value_.get ();
    }

    bool dBColumn_t::
    hasValue () const
    {
      return this->value_.present ();
    }

    void dBColumn_t::
    value (const value_type& x)
    {
      this->value_.set (x);
    }

    void dBColumn_t::
    setValue (const value_type& x)
    {
      this->value_.set (x);
    }

    void dBColumn_t::
    value (const value_optional& x)
    {
      this->value_ = x;
    }

    void dBColumn_t::
    value (::std::auto_ptr< value_type > x)
    {
      this->value_.set (x);
    }

    const dBColumn_t::null_optional& dBColumn_t::
    null () const
    {
      return this->null_;
    }

    dBColumn_t::null_optional& dBColumn_t::
    null ()
    {
      return this->null_;
    }

    const dBColumn_t::null_type& dBColumn_t::
    getNull () const
    {
      return this->null_.get ();
    }

    bool dBColumn_t::
    hasNull () const
    {
      return this->null_.present ();
    }

    void dBColumn_t::
    null (const null_type& x)
    {
      this->null_.set (x);
    }

    void dBColumn_t::
    setNull (const null_type& x)
    {
      this->null_.set (x);
    }

    void dBColumn_t::
    null (const null_optional& x)
    {
      this->null_ = x;
    }

    const dBColumn_t::fKeyTable_optional& dBColumn_t::
    fKeyTable () const
    {
      return this->fKeyTable_;
    }

    dBColumn_t::fKeyTable_optional& dBColumn_t::
    fKeyTable ()
    {
      return this->fKeyTable_;
    }

    const dBColumn_t::fKeyTable_type& dBColumn_t::
    getFKeyTable () const
    {
      return this->fKeyTable_.get ();
    }

    bool dBColumn_t::
    hasFKeyTable () const
    {
      return this->fKeyTable_.present ();
    }

    void dBColumn_t::
    fKeyTable (const fKeyTable_type& x)
    {
      this->fKeyTable_.set (x);
    }

    void dBColumn_t::
    setFKeyTable (const fKeyTable_type& x)
    {
      this->fKeyTable_.set (x);
    }

    void dBColumn_t::
    fKeyTable (const fKeyTable_optional& x)
    {
      this->fKeyTable_ = x;
    }

    void dBColumn_t::
    fKeyTable (::std::auto_ptr< fKeyTable_type > x)
    {
      this->fKeyTable_.set (x);
    }

    const dBColumn_t::fKeyColumn_optional& dBColumn_t::
    fKeyColumn () const
    {
      return this->fKeyColumn_;
    }

    dBColumn_t::fKeyColumn_optional& dBColumn_t::
    fKeyColumn ()
    {
      return this->fKeyColumn_;
    }

    const dBColumn_t::fKeyColumn_type& dBColumn_t::
    getFKeyColumn () const
    {
      return this->fKeyColumn_.get ();
    }

    bool dBColumn_t::
    hasFKeyColumn () const
    {
      return this->fKeyColumn_.present ();
    }

    void dBColumn_t::
    fKeyColumn (const fKeyColumn_type& x)
    {
      this->fKeyColumn_.set (x);
    }

    void dBColumn_t::
    setFKeyColumn (const fKeyColumn_type& x)
    {
      this->fKeyColumn_.set (x);
    }

    void dBColumn_t::
    fKeyColumn (const fKeyColumn_optional& x)
    {
      this->fKeyColumn_ = x;
    }

    void dBColumn_t::
    fKeyColumn (::std::auto_ptr< fKeyColumn_type > x)
    {
      this->fKeyColumn_.set (x);
    }


    // dBCheck_t
    // 

    const dBCheck_t::constraint_type& dBCheck_t::
    constraint () const
    {
      return this->constraint_.get ();
    }

    dBCheck_t::constraint_type& dBCheck_t::
    constraint ()
    {
      return this->constraint_.get ();
    }

    const dBCheck_t::constraint_type& dBCheck_t::
    getConstraint () const
    {
      return this->constraint_.get ();
    }

    bool dBCheck_t::
    hasConstraint () const
    {
      return this->constraint_.present ();
    }

    void dBCheck_t::
    constraint (const constraint_type& x)
    {
      this->constraint_.set (x);
    }

    void dBCheck_t::
    setConstraint (const constraint_type& x)
    {
      this->constraint_.set (x);
    }

    void dBCheck_t::
    constraint (::std::auto_ptr< constraint_type > x)
    {
      this->constraint_.set (x);
    }


    // dBRow_t
    // 

    const dBRow_t::dBCol_sequence& dBRow_t::
    dBCol () const
    {
      return this->dBCol_;
    }

    dBRow_t::dBCol_sequence& dBRow_t::
    dBCol ()
    {
      return this->dBCol_;
    }

    ::xml_schema::integer dBRow_t::
    getDBColCount () const
    {
      return this->dBCol_.size ();
    }

    const dBRow_t::dBCol_type& dBRow_t::
    getDBCol (int index) const
    {
      return this->dBCol_[index];
    }

    dBRow_t::dBCol_type& dBRow_t::
    getDBColReference (int index)
    {
      return this->dBCol_[index];
    }

    bool dBRow_t::
    hasDBCol () const
    {
      return ! (this->dBCol_.empty ());
    }

    void dBRow_t::
    removeAllDBCol ()
    {
      this->dBCol_.clear ();
    }

    void dBRow_t::
    dBCol (const dBCol_sequence& s)
    {
      this->dBCol_ = s;
    }

    void dBRow_t::
    addDBCol (const dBRow_t::dBCol_type& newDBCol)
    {
      this->dBCol_.push_back (newDBCol);
    }


    // dBTable
    // 

    const dBTable::dBColumn_sequence& dBTable::
    dBColumn () const
    {
      return this->dBColumn_;
    }

    dBTable::dBColumn_sequence& dBTable::
    dBColumn ()
    {
      return this->dBColumn_;
    }

    ::xml_schema::integer dBTable::
    getDBColumnCount () const
    {
      return this->dBColumn_.size ();
    }

    const dBTable::dBColumn_type& dBTable::
    getDBColumn (int index) const
    {
      return this->dBColumn_[index];
    }

    dBTable::dBColumn_type& dBTable::
    getDBColumnReference (int index)
    {
      return this->dBColumn_[index];
    }

    bool dBTable::
    hasDBColumn () const
    {
      return ! (this->dBColumn_.empty ());
    }

    void dBTable::
    removeAllDBColumn ()
    {
      this->dBColumn_.clear ();
    }

    void dBTable::
    dBColumn (const dBColumn_sequence& s)
    {
      this->dBColumn_ = s;
    }

    void dBTable::
    addDBColumn (const dBTable::dBColumn_type& newDBColumn)
    {
      this->dBColumn_.push_back (newDBColumn);
    }

    const dBTable::dBPKey_optional& dBTable::
    dBPKey () const
    {
      return this->dBPKey_;
    }

    dBTable::dBPKey_optional& dBTable::
    dBPKey ()
    {
      return this->dBPKey_;
    }

    const dBTable::dBPKey_type& dBTable::
    getDBPKey () const
    {
      return this->dBPKey_.get ();
    }

    bool dBTable::
    hasDBPKey () const
    {
      return this->dBPKey_.present ();
    }

    void dBTable::
    dBPKey (const dBPKey_type& x)
    {
      this->dBPKey_.set (x);
    }

    void dBTable::
    setDBPKey (const dBPKey_type& x)
    {
      this->dBPKey_.set (x);
    }

    void dBTable::
    dBPKey (const dBPKey_optional& x)
    {
      this->dBPKey_ = x;
    }

    void dBTable::
    dBPKey (::std::auto_ptr< dBPKey_type > x)
    {
      this->dBPKey_.set (x);
    }

    const dBTable::dBUnique_sequence& dBTable::
    dBUnique () const
    {
      return this->dBUnique_;
    }

    dBTable::dBUnique_sequence& dBTable::
    dBUnique ()
    {
      return this->dBUnique_;
    }

    ::xml_schema::integer dBTable::
    getDBUniqueCount () const
    {
      return this->dBUnique_.size ();
    }

    const dBTable::dBUnique_type& dBTable::
    getDBUnique (int index) const
    {
      return this->dBUnique_[index];
    }

    dBTable::dBUnique_type& dBTable::
    getDBUniqueReference (int index)
    {
      return this->dBUnique_[index];
    }

    bool dBTable::
    hasDBUnique () const
    {
      return ! (this->dBUnique_.empty ());
    }

    void dBTable::
    removeAllDBUnique ()
    {
      this->dBUnique_.clear ();
    }

    void dBTable::
    dBUnique (const dBUnique_sequence& s)
    {
      this->dBUnique_ = s;
    }

    void dBTable::
    addDBUnique (const dBTable::dBUnique_type& newDBUnique)
    {
      this->dBUnique_.push_back (newDBUnique);
    }

    const dBTable::dBCheck_sequence& dBTable::
    dBCheck () const
    {
      return this->dBCheck_;
    }

    dBTable::dBCheck_sequence& dBTable::
    dBCheck ()
    {
      return this->dBCheck_;
    }

    ::xml_schema::integer dBTable::
    getDBCheckCount () const
    {
      return this->dBCheck_.size ();
    }

    const dBTable::dBCheck_type& dBTable::
    getDBCheck (int index) const
    {
      return this->dBCheck_[index];
    }

    dBTable::dBCheck_type& dBTable::
    getDBCheckReference (int index)
    {
      return this->dBCheck_[index];
    }

    bool dBTable::
    hasDBCheck () const
    {
      return ! (this->dBCheck_.empty ());
    }

    void dBTable::
    removeAllDBCheck ()
    {
      this->dBCheck_.clear ();
    }

    void dBTable::
    dBCheck (const dBCheck_sequence& s)
    {
      this->dBCheck_ = s;
    }

    void dBTable::
    addDBCheck (const dBTable::dBCheck_type& newDBCheck)
    {
      this->dBCheck_.push_back (newDBCheck);
    }

    const dBTable::dBRow_sequence& dBTable::
    dBRow () const
    {
      return this->dBRow_;
    }

    dBTable::dBRow_sequence& dBTable::
    dBRow ()
    {
      return this->dBRow_;
    }

    ::xml_schema::integer dBTable::
    getDBRowCount () const
    {
      return this->dBRow_.size ();
    }

    const dBTable::dBRow_type& dBTable::
    getDBRow (int index) const
    {
      return this->dBRow_[index];
    }

    dBTable::dBRow_type& dBTable::
    getDBRowReference (int index)
    {
      return this->dBRow_[index];
    }

    bool dBTable::
    hasDBRow () const
    {
      return ! (this->dBRow_.empty ());
    }

    void dBTable::
    removeAllDBRow ()
    {
      this->dBRow_.clear ();
    }

    void dBTable::
    dBRow (const dBRow_sequence& s)
    {
      this->dBRow_ = s;
    }

    void dBTable::
    addDBRow (const dBTable::dBRow_type& newDBRow)
    {
      this->dBRow_.push_back (newDBRow);
    }

    const dBTable::tableName_type& dBTable::
    tableName () const
    {
      return this->tableName_.get ();
    }

    dBTable::tableName_type& dBTable::
    tableName ()
    {
      return this->tableName_.get ();
    }

    const dBTable::tableName_type& dBTable::
    getTableName () const
    {
      return this->tableName_.get ();
    }

    bool dBTable::
    hasTableName () const
    {
      return this->tableName_.present ();
    }

    void dBTable::
    tableName (const tableName_type& x)
    {
      this->tableName_.set (x);
    }

    void dBTable::
    setTableName (const tableName_type& x)
    {
      this->tableName_.set (x);
    }

    void dBTable::
    tableName (::std::auto_ptr< tableName_type > x)
    {
      this->tableName_.set (x);
    }

    const dBTable::dbHost_type& dBTable::
    dbHost () const
    {
      return this->dbHost_.get ();
    }

    dBTable::dbHost_type& dBTable::
    dbHost ()
    {
      return this->dbHost_.get ();
    }

    const dBTable::dbHost_type& dBTable::
    getDbHost () const
    {
      return this->dbHost_.get ();
    }

    bool dBTable::
    hasDbHost () const
    {
      return this->dbHost_.present ();
    }

    void dBTable::
    dbHost (const dbHost_type& x)
    {
      this->dbHost_.set (x);
    }

    void dBTable::
    setDbHost (const dbHost_type& x)
    {
      this->dbHost_.set (x);
    }

    void dBTable::
    dbHost (::std::auto_ptr< dbHost_type > x)
    {
      this->dbHost_.set (x);
    }

    const dBTable::dbName_type& dBTable::
    dbName () const
    {
      return this->dbName_.get ();
    }

    dBTable::dbName_type& dBTable::
    dbName ()
    {
      return this->dbName_.get ();
    }

    const dBTable::dbName_type& dBTable::
    getDbName () const
    {
      return this->dbName_.get ();
    }

    bool dBTable::
    hasDbName () const
    {
      return this->dbName_.present ();
    }

    void dBTable::
    dbName (const dbName_type& x)
    {
      this->dbName_.set (x);
    }

    void dBTable::
    setDbName (const dbName_type& x)
    {
      this->dbName_.set (x);
    }

    void dBTable::
    dbName (::std::auto_ptr< dbName_type > x)
    {
      this->dbName_.set (x);
    }

    const dBTable::dbType_optional& dBTable::
    dbType () const
    {
      return this->dbType_;
    }

    dBTable::dbType_optional& dBTable::
    dbType ()
    {
      return this->dbType_;
    }

    const dBTable::dbType_type& dBTable::
    getDbType () const
    {
      return this->dbType_.get ();
    }

    bool dBTable::
    hasDbType () const
    {
      return this->dbType_.present ();
    }

    void dBTable::
    dbType (const dbType_type& x)
    {
      this->dbType_.set (x);
    }

    void dBTable::
    setDbType (const dbType_type& x)
    {
      this->dbType_.set (x);
    }

    void dBTable::
    dbType (const dbType_optional& x)
    {
      this->dbType_ = x;
    }

    void dBTable::
    dbType (::std::auto_ptr< dbType_type > x)
    {
      this->dbType_.set (x);
    }

    const dBTable::dbPort_optional& dBTable::
    dbPort () const
    {
      return this->dbPort_;
    }

    dBTable::dbPort_optional& dBTable::
    dbPort ()
    {
      return this->dbPort_;
    }

    const dBTable::dbPort_type& dBTable::
    getDbPort () const
    {
      return this->dbPort_.get ();
    }

    bool dBTable::
    hasDbPort () const
    {
      return this->dbPort_.present ();
    }

    void dBTable::
    dbPort (const dbPort_type& x)
    {
      this->dbPort_.set (x);
    }

    void dBTable::
    setDbPort (const dbPort_type& x)
    {
      this->dbPort_.set (x);
    }

    void dBTable::
    dbPort (const dbPort_optional& x)
    {
      this->dbPort_ = x;
    }

    void dBTable::
    dbPort (::std::auto_ptr< dbPort_type > x)
    {
      this->dbPort_.set (x);
    }

    const dBTable::tableType_optional& dBTable::
    tableType () const
    {
      return this->tableType_;
    }

    dBTable::tableType_optional& dBTable::
    tableType ()
    {
      return this->tableType_;
    }

    const dBTable::tableType_type& dBTable::
    getTableType () const
    {
      return this->tableType_.get ();
    }

    bool dBTable::
    hasTableType () const
    {
      return this->tableType_.present ();
    }

    void dBTable::
    tableType (const tableType_type& x)
    {
      this->tableType_.set (x);
    }

    void dBTable::
    setTableType (const tableType_type& x)
    {
      this->tableType_.set (x);
    }

    void dBTable::
    tableType (const tableType_optional& x)
    {
      this->tableType_ = x;
    }

    void dBTable::
    tableType (::std::auto_ptr< tableType_type > x)
    {
      this->tableType_.set (x);
    }

    const dBTable::creationDate_optional& dBTable::
    creationDate () const
    {
      return this->creationDate_;
    }

    dBTable::creationDate_optional& dBTable::
    creationDate ()
    {
      return this->creationDate_;
    }

    const dBTable::creationDate_type& dBTable::
    getCreationDate () const
    {
      return this->creationDate_.get ();
    }

    bool dBTable::
    hasCreationDate () const
    {
      return this->creationDate_.present ();
    }

    void dBTable::
    creationDate (const creationDate_type& x)
    {
      this->creationDate_.set (x);
    }

    void dBTable::
    setCreationDate (const creationDate_type& x)
    {
      this->creationDate_.set (x);
    }

    void dBTable::
    creationDate (const creationDate_optional& x)
    {
      this->creationDate_ = x;
    }

    void dBTable::
    creationDate (::std::auto_ptr< creationDate_type > x)
    {
      this->creationDate_.set (x);
    }

    const dBTable::maintainer_optional& dBTable::
    maintainer () const
    {
      return this->maintainer_;
    }

    dBTable::maintainer_optional& dBTable::
    maintainer ()
    {
      return this->maintainer_;
    }

    const dBTable::maintainer_type& dBTable::
    getMaintainer () const
    {
      return this->maintainer_.get ();
    }

    bool dBTable::
    hasMaintainer () const
    {
      return this->maintainer_.present ();
    }

    void dBTable::
    maintainer (const maintainer_type& x)
    {
      this->maintainer_.set (x);
    }

    void dBTable::
    setMaintainer (const maintainer_type& x)
    {
      this->maintainer_.set (x);
    }

    void dBTable::
    maintainer (const maintainer_optional& x)
    {
      this->maintainer_ = x;
    }

    void dBTable::
    maintainer (::std::auto_ptr< maintainer_type > x)
    {
      this->maintainer_.set (x);
    }

    const dBTable::xmlOverDB_optional& dBTable::
    xmlOverDB () const
    {
      return this->xmlOverDB_;
    }

    dBTable::xmlOverDB_optional& dBTable::
    xmlOverDB ()
    {
      return this->xmlOverDB_;
    }

    const dBTable::xmlOverDB_type& dBTable::
    getXmlOverDB () const
    {
      return this->xmlOverDB_.get ();
    }

    bool dBTable::
    hasXmlOverDB () const
    {
      return this->xmlOverDB_.present ();
    }

    void dBTable::
    xmlOverDB (const xmlOverDB_type& x)
    {
      this->xmlOverDB_.set (x);
    }

    void dBTable::
    setXmlOverDB (const xmlOverDB_type& x)
    {
      this->xmlOverDB_.set (x);
    }

    void dBTable::
    xmlOverDB (const xmlOverDB_optional& x)
    {
      this->xmlOverDB_ = x;
    }

    const dBTable::ignoreDB_optional& dBTable::
    ignoreDB () const
    {
      return this->ignoreDB_;
    }

    dBTable::ignoreDB_optional& dBTable::
    ignoreDB ()
    {
      return this->ignoreDB_;
    }

    const dBTable::ignoreDB_type& dBTable::
    getIgnoreDB () const
    {
      return this->ignoreDB_.get ();
    }

    bool dBTable::
    hasIgnoreDB () const
    {
      return this->ignoreDB_.present ();
    }

    void dBTable::
    ignoreDB (const ignoreDB_type& x)
    {
      this->ignoreDB_.set (x);
    }

    void dBTable::
    setIgnoreDB (const ignoreDB_type& x)
    {
      this->ignoreDB_.set (x);
    }

    void dBTable::
    ignoreDB (const ignoreDB_optional& x)
    {
      this->ignoreDB_ = x;
    }

    const dBTable::addInsertTime_optional& dBTable::
    addInsertTime () const
    {
      return this->addInsertTime_;
    }

    dBTable::addInsertTime_optional& dBTable::
    addInsertTime ()
    {
      return this->addInsertTime_;
    }

    const dBTable::addInsertTime_type& dBTable::
    getAddInsertTime () const
    {
      return this->addInsertTime_.get ();
    }

    bool dBTable::
    hasAddInsertTime () const
    {
      return this->addInsertTime_.present ();
    }

    void dBTable::
    addInsertTime (const addInsertTime_type& x)
    {
      this->addInsertTime_.set (x);
    }

    void dBTable::
    setAddInsertTime (const addInsertTime_type& x)
    {
      this->addInsertTime_.set (x);
    }

    void dBTable::
    addInsertTime (const addInsertTime_optional& x)
    {
      this->addInsertTime_ = x;
    }

    const dBTable::addInsertUser_optional& dBTable::
    addInsertUser () const
    {
      return this->addInsertUser_;
    }

    dBTable::addInsertUser_optional& dBTable::
    addInsertUser ()
    {
      return this->addInsertUser_;
    }

    const dBTable::addInsertUser_type& dBTable::
    getAddInsertUser () const
    {
      return this->addInsertUser_.get ();
    }

    bool dBTable::
    hasAddInsertUser () const
    {
      return this->addInsertUser_.present ();
    }

    void dBTable::
    addInsertUser (const addInsertUser_type& x)
    {
      this->addInsertUser_.set (x);
    }

    void dBTable::
    setAddInsertUser (const addInsertUser_type& x)
    {
      this->addInsertUser_.set (x);
    }

    void dBTable::
    addInsertUser (const addInsertUser_optional& x)
    {
      this->addInsertUser_ = x;
    }

    const dBTable::addUpdateTime_optional& dBTable::
    addUpdateTime () const
    {
      return this->addUpdateTime_;
    }

    dBTable::addUpdateTime_optional& dBTable::
    addUpdateTime ()
    {
      return this->addUpdateTime_;
    }

    const dBTable::addUpdateTime_type& dBTable::
    getAddUpdateTime () const
    {
      return this->addUpdateTime_.get ();
    }

    bool dBTable::
    hasAddUpdateTime () const
    {
      return this->addUpdateTime_.present ();
    }

    void dBTable::
    addUpdateTime (const addUpdateTime_type& x)
    {
      this->addUpdateTime_.set (x);
    }

    void dBTable::
    setAddUpdateTime (const addUpdateTime_type& x)
    {
      this->addUpdateTime_.set (x);
    }

    void dBTable::
    addUpdateTime (const addUpdateTime_optional& x)
    {
      this->addUpdateTime_ = x;
    }

    const dBTable::addUpdateUser_optional& dBTable::
    addUpdateUser () const
    {
      return this->addUpdateUser_;
    }

    dBTable::addUpdateUser_optional& dBTable::
    addUpdateUser ()
    {
      return this->addUpdateUser_;
    }

    const dBTable::addUpdateUser_type& dBTable::
    getAddUpdateUser () const
    {
      return this->addUpdateUser_.get ();
    }

    bool dBTable::
    hasAddUpdateUser () const
    {
      return this->addUpdateUser_.present ();
    }

    void dBTable::
    addUpdateUser (const addUpdateUser_type& x)
    {
      this->addUpdateUser_.set (x);
    }

    void dBTable::
    setAddUpdateUser (const addUpdateUser_type& x)
    {
      this->addUpdateUser_.set (x);
    }

    void dBTable::
    addUpdateUser (const addUpdateUser_optional& x)
    {
      this->addUpdateUser_ = x;
    }

    const dBTable::schema_optional& dBTable::
    schema () const
    {
      return this->schema_;
    }

    dBTable::schema_optional& dBTable::
    schema ()
    {
      return this->schema_;
    }

    const dBTable::schema_type& dBTable::
    getSchema () const
    {
      return this->schema_.get ();
    }

    bool dBTable::
    hasSchema () const
    {
      return this->schema_.present ();
    }

    void dBTable::
    schema (const schema_type& x)
    {
      this->schema_.set (x);
    }

    void dBTable::
    setSchema (const schema_type& x)
    {
      this->schema_.set (x);
    }

    void dBTable::
    schema (const schema_optional& x)
    {
      this->schema_ = x;
    }

    void dBTable::
    schema (::std::auto_ptr< schema_type > x)
    {
      this->schema_.set (x);
    }
  }
}

#include <xsd/cxx/xml/dom/parsing-source.hxx>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace nova
{
  namespace database
  {
    // Tolerance_t
    //

    Tolerance_t::
    Tolerance_t ()
    : ::xml_schema::type (),
      tolValue_ (this),
      tolType_ (this)
    {
    }

    Tolerance_t::
    Tolerance_t (const tolValue_type& tolValue,
                 const tolType_type& tolType)
    : ::xml_schema::type (),
      tolValue_ (tolValue, this),
      tolType_ (tolType, this)
    {
    }

    Tolerance_t::
    Tolerance_t (const Tolerance_t& x,
                 ::xml_schema::flags f,
                 ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      tolValue_ (x.tolValue_, f, this),
      tolType_ (x.tolType_, f, this)
    {
    }

    Tolerance_t::
    Tolerance_t (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f,
                 ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      tolValue_ (this),
      tolType_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void Tolerance_t::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "tolValue" && n.namespace_ ().empty ())
        {
          this->tolValue_.set (tolValue_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "tolType" && n.namespace_ ().empty ())
        {
          this->tolType_.set (tolType_traits::create (i, f, this));
          continue;
        }
      }

      if (!tolValue_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (Tolerance_t::tolValue) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "tolValue",
            "");
        }
      }

      if (!tolType_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (Tolerance_t::tolType) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "tolType",
            "");
        }
      }
    }

    Tolerance_t* Tolerance_t::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class Tolerance_t (*this, f, c);
    }

    Tolerance_t& Tolerance_t::
    operator= (const Tolerance_t& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->tolValue_ = x.tolValue_;
        this->tolType_ = x.tolType_;
      }

      return *this;
    }

    Tolerance_t::
    ~Tolerance_t ()
    {
    }

    void Tolerance_t::
    copyNeededFields (const Tolerance_t& x)
    {
      if (x.hasTolType()) {
        if (! this->hasTolType()) {
          this->setTolType(x.getTolType());
        }
        else {
          copyTraits<tolType_type>::copyNeededFields(x.getTolType(), this->tolType());
        }
      }
      if (x.hasTolValue()) {
        if (! this->hasTolValue()) {
          this->setTolValue(x.getTolValue());
        }
        else {
          copyTraits<tolValue_type>::copyNeededFields(x.getTolValue(), this->tolValue());
        }
      }
    }

    // dBColumn_t
    //

    dBColumn_t::
    dBColumn_t ()
    : ::xml_schema::type (),
      tolerance_ (this),
      name_ (this),
      colType_ (this),
      value_ (this),
      null_ (this),
      fKeyTable_ (this),
      fKeyColumn_ (this)
    {
    }

    dBColumn_t::
    dBColumn_t (const name_type& name)
    : ::xml_schema::type (),
      tolerance_ (this),
      name_ (name, this),
      colType_ (this),
      value_ (this),
      null_ (this),
      fKeyTable_ (this),
      fKeyColumn_ (this)
    {
    }

    dBColumn_t::
    dBColumn_t (const dBColumn_t& x,
                ::xml_schema::flags f,
                ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      tolerance_ (x.tolerance_, f, this),
      name_ (x.name_, f, this),
      colType_ (x.colType_, f, this),
      value_ (x.value_, f, this),
      null_ (x.null_, f, this),
      fKeyTable_ (x.fKeyTable_, f, this),
      fKeyColumn_ (x.fKeyColumn_, f, this)
    {
    }

    dBColumn_t::
    dBColumn_t (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f,
                ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      tolerance_ (this),
      name_ (this),
      colType_ (this),
      value_ (this),
      null_ (this),
      fKeyTable_ (this),
      fKeyColumn_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void dBColumn_t::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // tolerance
        //
        if (n.name () == "tolerance" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< tolerance_type > r (
            tolerance_traits::create (i, f, this));

          if (!this->tolerance_)
          {
            this->tolerance_.set (r);
            continue;
          }
        }

        break;
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "name" && n.namespace_ ().empty ())
        {
          this->name_.set (name_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "colType" && n.namespace_ ().empty ())
        {
          this->colType_.set (colType_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "value" && n.namespace_ ().empty ())
        {
          this->value_.set (value_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "null" && n.namespace_ ().empty ())
        {
          this->null_.set (null_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "fKeyTable" && n.namespace_ ().empty ())
        {
          this->fKeyTable_.set (fKeyTable_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "fKeyColumn" && n.namespace_ ().empty ())
        {
          this->fKeyColumn_.set (fKeyColumn_traits::create (i, f, this));
          continue;
        }
      }

      if (!name_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (dBColumn_t::name) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "name",
            "");
        }
      }
    }

    dBColumn_t* dBColumn_t::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class dBColumn_t (*this, f, c);
    }

    dBColumn_t& dBColumn_t::
    operator= (const dBColumn_t& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->tolerance_ = x.tolerance_;
        this->name_ = x.name_;
        this->colType_ = x.colType_;
        this->value_ = x.value_;
        this->null_ = x.null_;
        this->fKeyTable_ = x.fKeyTable_;
        this->fKeyColumn_ = x.fKeyColumn_;
      }

      return *this;
    }

    dBColumn_t::
    ~dBColumn_t ()
    {
    }

    void dBColumn_t::
    copyNeededFields (const dBColumn_t& x)
    {
      if (x.hasName()) {
        if (! this->hasName()) {
          this->setName(x.getName());
        }
        else {
          copyTraits<name_type>::copyNeededFields(x.getName(), this->name());
        }
      }
      if (x.hasTolerance()) {
        if (! this->hasTolerance()) {
          this->setTolerance(x.getTolerance());
        }
        else {
          copyTraits<tolerance_type>::copyNeededFields(x.getTolerance(), this->tolerance());
        }
      }
    }

    // dBCheck_t
    //

    dBCheck_t::
    dBCheck_t ()
    : ::xml_schema::type (),
      constraint_ (this)
    {
    }

    dBCheck_t::
    dBCheck_t (const constraint_type& constraint)
    : ::xml_schema::type (),
      constraint_ (constraint, this)
    {
    }

    dBCheck_t::
    dBCheck_t (const dBCheck_t& x,
               ::xml_schema::flags f,
               ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      constraint_ (x.constraint_, f, this)
    {
    }

    dBCheck_t::
    dBCheck_t (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f,
               ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      constraint_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void dBCheck_t::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "constraint" && n.namespace_ ().empty ())
        {
          this->constraint_.set (constraint_traits::create (i, f, this));
          continue;
        }
      }

      if (!constraint_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (dBCheck_t::constraint) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "constraint",
            "");
        }
      }
    }

    dBCheck_t* dBCheck_t::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class dBCheck_t (*this, f, c);
    }

    dBCheck_t& dBCheck_t::
    operator= (const dBCheck_t& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->constraint_ = x.constraint_;
      }

      return *this;
    }

    dBCheck_t::
    ~dBCheck_t ()
    {
    }

    void dBCheck_t::
    copyNeededFields (const dBCheck_t& x)
    {
      if (x.hasConstraint()) {
        if (! this->hasConstraint()) {
          this->setConstraint(x.getConstraint());
        }
        else {
          copyTraits<constraint_type>::copyNeededFields(x.getConstraint(), this->constraint());
        }
      }
    }

    // dBRow_t
    //

    dBRow_t::
    dBRow_t ()
    : ::xml_schema::type (),
      dBCol_ (this)
    {
    }

    dBRow_t::
    dBRow_t (const dBRow_t& x,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      dBCol_ (x.dBCol_, f, this)
    {
    }

    dBRow_t::
    dBRow_t (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      dBCol_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void dBRow_t::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // dBCol
        //
        if (n.name () == "dBCol" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< dBCol_type > r (
            dBCol_traits::create (i, f, this));

          this->dBCol_.push_back (r);
          continue;
        }

        break;
      }
    }

    dBRow_t* dBRow_t::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class dBRow_t (*this, f, c);
    }

    dBRow_t& dBRow_t::
    operator= (const dBRow_t& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->dBCol_ = x.dBCol_;
      }

      return *this;
    }

    dBRow_t::
    ~dBRow_t ()
    {
    }

    void dBRow_t::
    copyNeededFields (const dBRow_t& x)
    {
      if (x.hasDBCol() && x.getDBColCount() > 0) {
        if (! this->hasDBCol() || this->getDBColCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getDBColCount(); ++idx) {
              this->addDBCol(x.getDBCol(idx));
          }
        }
        //else {
        //  copyTraits<dBCol_type>::copyNeededFields(x.getDBCol(), this->dBCol());
        //}
      }
    }

    // dBTable
    //

    dBTable::
    dBTable ()
    : ::xml_schema::type (),
      dBColumn_ (this),
      dBPKey_ (this),
      dBUnique_ (this),
      dBCheck_ (this),
      dBRow_ (this),
      tableName_ (this),
      dbHost_ (this),
      dbName_ (this),
      dbType_ (this),
      dbPort_ (this),
      tableType_ (this),
      creationDate_ (this),
      maintainer_ (this),
      xmlOverDB_ (this),
      ignoreDB_ (this),
      addInsertTime_ (this),
      addInsertUser_ (this),
      addUpdateTime_ (this),
      addUpdateUser_ (this),
      schema_ (this)
    {
    }

    dBTable::
    dBTable (const tableName_type& tableName,
             const dbHost_type& dbHost,
             const dbName_type& dbName)
    : ::xml_schema::type (),
      dBColumn_ (this),
      dBPKey_ (this),
      dBUnique_ (this),
      dBCheck_ (this),
      dBRow_ (this),
      tableName_ (tableName, this),
      dbHost_ (dbHost, this),
      dbName_ (dbName, this),
      dbType_ (this),
      dbPort_ (this),
      tableType_ (this),
      creationDate_ (this),
      maintainer_ (this),
      xmlOverDB_ (this),
      ignoreDB_ (this),
      addInsertTime_ (this),
      addInsertUser_ (this),
      addUpdateTime_ (this),
      addUpdateUser_ (this),
      schema_ (this)
    {
    }

    dBTable::
    dBTable (const dBTable& x,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      dBColumn_ (x.dBColumn_, f, this),
      dBPKey_ (x.dBPKey_, f, this),
      dBUnique_ (x.dBUnique_, f, this),
      dBCheck_ (x.dBCheck_, f, this),
      dBRow_ (x.dBRow_, f, this),
      tableName_ (x.tableName_, f, this),
      dbHost_ (x.dbHost_, f, this),
      dbName_ (x.dbName_, f, this),
      dbType_ (x.dbType_, f, this),
      dbPort_ (x.dbPort_, f, this),
      tableType_ (x.tableType_, f, this),
      creationDate_ (x.creationDate_, f, this),
      maintainer_ (x.maintainer_, f, this),
      xmlOverDB_ (x.xmlOverDB_, f, this),
      ignoreDB_ (x.ignoreDB_, f, this),
      addInsertTime_ (x.addInsertTime_, f, this),
      addInsertUser_ (x.addInsertUser_, f, this),
      addUpdateTime_ (x.addUpdateTime_, f, this),
      addUpdateUser_ (x.addUpdateUser_, f, this),
      schema_ (x.schema_, f, this)
    {
    }

    dBTable::
    dBTable (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f,
             ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      dBColumn_ (this),
      dBPKey_ (this),
      dBUnique_ (this),
      dBCheck_ (this),
      dBRow_ (this),
      tableName_ (this),
      dbHost_ (this),
      dbName_ (this),
      dbType_ (this),
      dbPort_ (this),
      tableType_ (this),
      creationDate_ (this),
      maintainer_ (this),
      xmlOverDB_ (this),
      ignoreDB_ (this),
      addInsertTime_ (this),
      addInsertUser_ (this),
      addUpdateTime_ (this),
      addUpdateUser_ (this),
      schema_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void dBTable::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // dBColumn
        //
        if (n.name () == "dBColumn" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< dBColumn_type > r (
            dBColumn_traits::create (i, f, this));

          this->dBColumn_.push_back (r);
          continue;
        }

        // dBPKey
        //
        if (n.name () == "dBPKey" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< dBPKey_type > r (
            dBPKey_traits::create (i, f, this));

          if (!this->dBPKey_)
          {
            this->dBPKey_.set (r);
            continue;
          }
        }

        // dBUnique
        //
        if (n.name () == "dBUnique" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< dBUnique_type > r (
            dBUnique_traits::create (i, f, this));

          this->dBUnique_.push_back (r);
          continue;
        }

        // dBCheck
        //
        if (n.name () == "dBCheck" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< dBCheck_type > r (
            dBCheck_traits::create (i, f, this));

          this->dBCheck_.push_back (r);
          continue;
        }

        // dBRow
        //
        if (n.name () == "dBRow" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< dBRow_type > r (
            dBRow_traits::create (i, f, this));

          this->dBRow_.push_back (r);
          continue;
        }

        break;
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "tableName" && n.namespace_ ().empty ())
        {
          this->tableName_.set (tableName_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "dbHost" && n.namespace_ ().empty ())
        {
          this->dbHost_.set (dbHost_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "dbName" && n.namespace_ ().empty ())
        {
          this->dbName_.set (dbName_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "dbType" && n.namespace_ ().empty ())
        {
          this->dbType_.set (dbType_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "dbPort" && n.namespace_ ().empty ())
        {
          this->dbPort_.set (dbPort_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "tableType" && n.namespace_ ().empty ())
        {
          this->tableType_.set (tableType_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "creationDate" && n.namespace_ ().empty ())
        {
          this->creationDate_.set (creationDate_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "maintainer" && n.namespace_ ().empty ())
        {
          this->maintainer_.set (maintainer_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "xmlOverDB" && n.namespace_ ().empty ())
        {
          this->xmlOverDB_.set (xmlOverDB_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "ignoreDB" && n.namespace_ ().empty ())
        {
          this->ignoreDB_.set (ignoreDB_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "addInsertTime" && n.namespace_ ().empty ())
        {
          this->addInsertTime_.set (addInsertTime_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "addInsertUser" && n.namespace_ ().empty ())
        {
          this->addInsertUser_.set (addInsertUser_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "addUpdateTime" && n.namespace_ ().empty ())
        {
          this->addUpdateTime_.set (addUpdateTime_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "addUpdateUser" && n.namespace_ ().empty ())
        {
          this->addUpdateUser_.set (addUpdateUser_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "schema" && n.namespace_ ().empty ())
        {
          this->schema_.set (schema_traits::create (i, f, this));
          continue;
        }
      }

      if (!tableName_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (dBTable::tableName) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "tableName",
            "");
        }
      }

      if (!dbHost_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (dBTable::dbHost) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "dbHost",
            "");
        }
      }

      if (!dbName_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (dBTable::dbName) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "dbName",
            "");
        }
      }
    }

    dBTable* dBTable::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class dBTable (*this, f, c);
    }

    dBTable& dBTable::
    operator= (const dBTable& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->dBColumn_ = x.dBColumn_;
        this->dBPKey_ = x.dBPKey_;
        this->dBUnique_ = x.dBUnique_;
        this->dBCheck_ = x.dBCheck_;
        this->dBRow_ = x.dBRow_;
        this->tableName_ = x.tableName_;
        this->dbHost_ = x.dbHost_;
        this->dbName_ = x.dbName_;
        this->dbType_ = x.dbType_;
        this->dbPort_ = x.dbPort_;
        this->tableType_ = x.tableType_;
        this->creationDate_ = x.creationDate_;
        this->maintainer_ = x.maintainer_;
        this->xmlOverDB_ = x.xmlOverDB_;
        this->ignoreDB_ = x.ignoreDB_;
        this->addInsertTime_ = x.addInsertTime_;
        this->addInsertUser_ = x.addInsertUser_;
        this->addUpdateTime_ = x.addUpdateTime_;
        this->addUpdateUser_ = x.addUpdateUser_;
        this->schema_ = x.schema_;
      }

      return *this;
    }

    dBTable::
    ~dBTable ()
    {
    }

    ::std::string dBTable::
    serialize () const
    {
      // To avoid problems with multi-threaded access to
      // CST XSD ser/deserialization code and underlying
      // Xerces-C++ code, we prevent concurrent access
      // to any serialization code by any class that
      // inherits from XMLSerializable via the use of a
      // static mutex in XMLSerializable.
      boost::mutex::scoped_lock lock(_serializationMutex);

      ::std::ostringstream oss;
      dBTable_ (oss, *this);
      return oss.str();
    }

    void dBTable::
    deserialize (const ::std::string& serializedData)
    {
      // To avoid problems with multi-threaded access to
      // CST XSD ser/deserialization code and underlying
      // Xerces-C++ code, we prevent concurrent access
      // to any deserialization code by any class that
      // inherits from XMLSerializable via the use of a
      // static mutex in XMLSerializable.
      boost::mutex::scoped_lock lock(_serializationMutex);

      // initialization for XSD
      ::xml_schema::flags flags = ::xml_schema::flags::dont_validate;
      ::xsd::cxx::xml::auto_initializer autoInit
            ((flags & ::xml_schema::flags::dont_initialize) == 0,
             (flags & ::xml_schema::flags::keep_dom) == 0);
      ::xsd::cxx::tree::error_handler< char > errorHandler;
      ::xml_schema::properties props;

      // wrap the string in an input stream
      ::std::istringstream iss (serializedData);
      ::xsd::cxx::xml::sax::std_input_source isrc (iss);

      // create a DOM from the input stream
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > doc (
          ::xsd::cxx::xml::dom::parse< char > (isrc, errorHandler, props, flags));
      errorHandler.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      // do the deserialization
      ::xsd::cxx::xml::dom::parser< char > parser (*(doc->getDocumentElement()), true, false, true);
      this->parse (parser, flags);
    }

    ::std::string dBTable::
    getClassName () const
    {
      return "nova::database::dBTable";
    }

    ::boost::shared_ptr< ::novadaq::XMLSerializable > dBTable::
    clone () const
    {
      dBTable *copy = this->_clone ();
      boost::shared_ptr<novadaq::XMLSerializable> copyPtr (copy);
      return copyPtr;
    }

    void dBTable::
    registerForDeserialization ()
    {
      boost::shared_ptr<novadaq::XMLSerializable> msgPtr;
      novadaq::XMLDeserializationRegistry&
        deserRegistry = novadaq::XMLDeserializationRegistry::getInstance();
      msgPtr.reset(new dBTable());
      deserRegistry.registerClass(msgPtr->getClassName(), msgPtr);
    }

    void dBTable::
    copyNeededFields (const dBTable& x)
    {
      if (x.hasDBPKey()) {
        if (! this->hasDBPKey()) {
          this->setDBPKey(x.getDBPKey());
        }
        else {
          copyTraits<dBPKey_type>::copyNeededFields(x.getDBPKey(), this->dBPKey());
        }
      }
      if (x.hasDbHost()) {
        if (! this->hasDbHost()) {
          this->setDbHost(x.getDbHost());
        }
        else {
          copyTraits<dbHost_type>::copyNeededFields(x.getDbHost(), this->dbHost());
        }
      }
      if (x.hasDbName()) {
        if (! this->hasDbName()) {
          this->setDbName(x.getDbName());
        }
        else {
          copyTraits<dbName_type>::copyNeededFields(x.getDbName(), this->dbName());
        }
      }
      if (x.hasTableName()) {
        if (! this->hasTableName()) {
          this->setTableName(x.getTableName());
        }
        else {
          copyTraits<tableName_type>::copyNeededFields(x.getTableName(), this->tableName());
        }
      }
      if (x.hasDBCheck() && x.getDBCheckCount() > 0) {
        if (! this->hasDBCheck() || this->getDBCheckCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getDBCheckCount(); ++idx) {
              this->addDBCheck(x.getDBCheck(idx));
          }
        }
        //else {
        //  copyTraits<dBCheck_type>::copyNeededFields(x.getDBCheck(), this->dBCheck());
        //}
      }
      if (x.hasDBColumn() && x.getDBColumnCount() > 0) {
        if (! this->hasDBColumn() || this->getDBColumnCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getDBColumnCount(); ++idx) {
              this->addDBColumn(x.getDBColumn(idx));
          }
        }
        //else {
        //  copyTraits<dBColumn_type>::copyNeededFields(x.getDBColumn(), this->dBColumn());
        //}
      }
      if (x.hasDBRow() && x.getDBRowCount() > 0) {
        if (! this->hasDBRow() || this->getDBRowCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getDBRowCount(); ++idx) {
              this->addDBRow(x.getDBRow(idx));
          }
        }
        //else {
        //  copyTraits<dBRow_type>::copyNeededFields(x.getDBRow(), this->dBRow());
        //}
      }
      if (x.hasDBUnique() && x.getDBUniqueCount() > 0) {
        if (! this->hasDBUnique() || this->getDBUniqueCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getDBUniqueCount(); ++idx) {
              this->addDBUnique(x.getDBUnique(idx));
          }
        }
        //else {
        //  copyTraits<dBUnique_type>::copyNeededFields(x.getDBUnique(), this->dBUnique());
        //}
      }
    }
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace nova
{
  namespace database
  {
    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (const ::std::string& u,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::auto_ptr< ::nova::database::dBTable > (
        ::nova::database::dBTable_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (const ::std::string& u,
              ::xml_schema::error_handler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::nova::database::dBTable > (
        ::nova::database::dBTable_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (const ::std::string& u,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::nova::database::dBTable > (
        ::nova::database::dBTable_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::std::istream& is,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::nova::database::dBTable_ (isrc, f, p);
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::std::istream& is,
              ::xml_schema::error_handler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::nova::database::dBTable_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::std::istream& is,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::nova::database::dBTable_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::std::istream& is,
              const ::std::string& sid,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::nova::database::dBTable_ (isrc, f, p);
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::std::istream& is,
              const ::std::string& sid,
              ::xml_schema::error_handler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::nova::database::dBTable_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::std::istream& is,
              const ::std::string& sid,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::nova::database::dBTable_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::xercesc::InputSource& i,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::auto_ptr< ::nova::database::dBTable > (
        ::nova::database::dBTable_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::xercesc::InputSource& i,
              ::xml_schema::error_handler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::nova::database::dBTable > (
        ::nova::database::dBTable_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::xercesc::InputSource& i,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::nova::database::dBTable > (
        ::nova::database::dBTable_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (const ::xercesc::DOMDocument& doc,
              ::xml_schema::flags f,
              const ::xml_schema::properties& p)
    {
      if (f & ::xml_schema::flags::keep_dom)
      {
        ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
          static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

        return ::std::auto_ptr< ::nova::database::dBTable > (
          ::nova::database::dBTable_ (
            d, f | ::xml_schema::flags::own_dom, p));
      }

      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "dBTable" &&
          n.namespace_ () == "")
      {
        ::std::auto_ptr< ::nova::database::dBTable > r (
          ::xsd::cxx::tree::traits< ::nova::database::dBTable, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "dBTable",
        "");
    }

    ::std::auto_ptr< ::nova::database::dBTable >
    dBTable_ (::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d,
              ::xml_schema::flags f,
              const ::xml_schema::properties&)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > c (
        ((f & ::xml_schema::flags::keep_dom) &&
         !(f & ::xml_schema::flags::own_dom))
        ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
        : 0);

      ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (f & ::xml_schema::flags::keep_dom)
        doc.setUserData (::xml_schema::dom::tree_node_key,
                         (c.get () ? &c : &d),
                         0);

      if (n.name () == "dBTable" &&
          n.namespace_ () == "")
      {
        ::std::auto_ptr< ::nova::database::dBTable > r (
          ::xsd::cxx::tree::traits< ::nova::database::dBTable, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "dBTable",
        "");
    }
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

namespace nova
{
  namespace database
  {
    void
    dBTable_ (::std::ostream& o,
              const ::nova::database::dBTable& s,
              const ::xml_schema::namespace_infomap& m,
              const ::std::string& e,
              ::xml_schema::flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::nova::database::dBTable_ (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    dBTable_ (::std::ostream& o,
              const ::nova::database::dBTable& s,
              ::xml_schema::error_handler& h,
              const ::xml_schema::namespace_infomap& m,
              const ::std::string& e,
              ::xml_schema::flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::nova::database::dBTable_ (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    dBTable_ (::std::ostream& o,
              const ::nova::database::dBTable& s,
              ::xercesc::DOMErrorHandler& h,
              const ::xml_schema::namespace_infomap& m,
              const ::std::string& e,
              ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::nova::database::dBTable_ (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    dBTable_ (::xercesc::XMLFormatTarget& t,
              const ::nova::database::dBTable& s,
              const ::xml_schema::namespace_infomap& m,
              const ::std::string& e,
              ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::nova::database::dBTable_ (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    dBTable_ (::xercesc::XMLFormatTarget& t,
              const ::nova::database::dBTable& s,
              ::xml_schema::error_handler& h,
              const ::xml_schema::namespace_infomap& m,
              const ::std::string& e,
              ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::nova::database::dBTable_ (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    dBTable_ (::xercesc::XMLFormatTarget& t,
              const ::nova::database::dBTable& s,
              ::xercesc::DOMErrorHandler& h,
              const ::xml_schema::namespace_infomap& m,
              const ::std::string& e,
              ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::nova::database::dBTable_ (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    dBTable_ (::xercesc::DOMDocument& d,
              const ::nova::database::dBTable& s,
              ::xml_schema::flags)
    {
      ::xercesc::DOMElement& e (*d.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "dBTable" &&
          n.namespace_ () == "")
      {
        e << s;
      }
      else
      {
        throw ::xsd::cxx::tree::unexpected_element < char > (
          n.name (),
          n.namespace_ (),
          "dBTable",
          "");
      }
    }

    ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument >
    dBTable_ (const ::nova::database::dBTable& s,
              const ::xml_schema::namespace_infomap& m,
              ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::serialize< char > (
          "dBTable",
          "",
          m, f));

      ::nova::database::dBTable_ (*d, s, f);
      return d;
    }

    void
    operator<< (::xercesc::DOMElement& e, const Tolerance_t& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // tolValue
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "tolValue",
            e));

        if (! i.hasTolValue ()) {
          std::cerr << "WARNING: attempting to serialize a Tolerance_t with an empty tolValue field!" << std::endl;
        }
        a << i.tolValue ();
      }

      // tolType
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "tolType",
            e));

        if (! i.hasTolType ()) {
          std::cerr << "WARNING: attempting to serialize a Tolerance_t with an empty tolType field!" << std::endl;
        }
        a << i.tolType ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const dBColumn_t& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // tolerance
      //
      if (i.tolerance ())
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "tolerance",
            e));

        s << *i.tolerance ();
      }

      // name
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "name",
            e));

        if (! i.hasName ()) {
          std::cerr << "WARNING: attempting to serialize a dBColumn_t with an empty name field!" << std::endl;
        }
        a << i.name ();
      }

      // colType
      //
      if (i.colType ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "colType",
            e));

        a << *i.colType ();
      }

      // value
      //
      if (i.value ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "value",
            e));

        a << *i.value ();
      }

      // null
      //
      if (i.null ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "null",
            e));

        a << *i.null ();
      }

      // fKeyTable
      //
      if (i.fKeyTable ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "fKeyTable",
            e));

        a << *i.fKeyTable ();
      }

      // fKeyColumn
      //
      if (i.fKeyColumn ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "fKeyColumn",
            e));

        a << *i.fKeyColumn ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const dBCheck_t& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // constraint
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "constraint",
            e));

        if (! i.hasConstraint ()) {
          std::cerr << "WARNING: attempting to serialize a dBCheck_t with an empty constraint field!" << std::endl;
        }
        a << i.constraint ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const dBRow_t& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // dBCol
      //
      for (dBRow_t::dBCol_const_iterator
           b (i.dBCol ().begin ()), n (i.dBCol ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "dBCol",
            e));

        s << *b;
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const dBTable& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // dBColumn
      //
      for (dBTable::dBColumn_const_iterator
           b (i.dBColumn ().begin ()), n (i.dBColumn ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "dBColumn",
            e));

        s << *b;
      }

      // dBPKey
      //
      if (i.dBPKey ())
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "dBPKey",
            e));

        s << *i.dBPKey ();
      }

      // dBUnique
      //
      for (dBTable::dBUnique_const_iterator
           b (i.dBUnique ().begin ()), n (i.dBUnique ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "dBUnique",
            e));

        s << *b;
      }

      // dBCheck
      //
      for (dBTable::dBCheck_const_iterator
           b (i.dBCheck ().begin ()), n (i.dBCheck ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "dBCheck",
            e));

        s << *b;
      }

      // dBRow
      //
      for (dBTable::dBRow_const_iterator
           b (i.dBRow ().begin ()), n (i.dBRow ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "dBRow",
            e));

        s << *b;
      }

      // tableName
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "tableName",
            e));

        if (! i.hasTableName ()) {
          std::cerr << "WARNING: attempting to serialize a dBTable with an empty tableName field!" << std::endl;
        }
        a << i.tableName ();
      }

      // dbHost
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "dbHost",
            e));

        if (! i.hasDbHost ()) {
          std::cerr << "WARNING: attempting to serialize a dBTable with an empty dbHost field!" << std::endl;
        }
        a << i.dbHost ();
      }

      // dbName
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "dbName",
            e));

        if (! i.hasDbName ()) {
          std::cerr << "WARNING: attempting to serialize a dBTable with an empty dbName field!" << std::endl;
        }
        a << i.dbName ();
      }

      // dbType
      //
      if (i.dbType ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "dbType",
            e));

        a << *i.dbType ();
      }

      // dbPort
      //
      if (i.dbPort ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "dbPort",
            e));

        a << *i.dbPort ();
      }

      // tableType
      //
      if (i.tableType ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "tableType",
            e));

        a << *i.tableType ();
      }

      // creationDate
      //
      if (i.creationDate ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "creationDate",
            e));

        a << *i.creationDate ();
      }

      // maintainer
      //
      if (i.maintainer ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "maintainer",
            e));

        a << *i.maintainer ();
      }

      // xmlOverDB
      //
      if (i.xmlOverDB ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "xmlOverDB",
            e));

        a << *i.xmlOverDB ();
      }

      // ignoreDB
      //
      if (i.ignoreDB ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "ignoreDB",
            e));

        a << *i.ignoreDB ();
      }

      // addInsertTime
      //
      if (i.addInsertTime ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "addInsertTime",
            e));

        a << *i.addInsertTime ();
      }

      // addInsertUser
      //
      if (i.addInsertUser ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "addInsertUser",
            e));

        a << *i.addInsertUser ();
      }

      // addUpdateTime
      //
      if (i.addUpdateTime ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "addUpdateTime",
            e));

        a << *i.addUpdateTime ();
      }

      // addUpdateUser
      //
      if (i.addUpdateUser ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "addUpdateUser",
            e));

        a << *i.addUpdateUser ();
      }

      // schema
      //
      if (i.schema ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "schema",
            e));

        a << *i.schema ();
      }
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

