#include <iostream>
#include <iomanip>
#include <vector>
#include "NovaDAQUtilities/LocationUtils.h"
#include "NovaDatabase/Table.h"

using namespace nova::database;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc != 4) {
    cout << "Usage: NovaSSVtoDB [NDOS|FarDet|NearDet] [XML table definition file] [data file]"
	 << endl;
    exit(1);
  }

  Table* t;

  try {
    t = new Table(argv[2]);
  }
  catch (std::runtime_error& e) {
    std::cerr << e.what() << "  Exiting..." << std::endl;
    exit(2);
  }

  if (! t->SetDetector(argv[1])) exit(1);

  if (t->LoadFromSSV(argv[3]))
    t->WriteToDB();

  return 0;

}
